#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

typedef struct _RingSvcChannelFuture RingSvcChannelFuture;

typedef struct _RingSvcChannelFutureClass RingSvcChannelFutureClass;

GType ring_svc_channel_future_get_type (void);
#define RING_TYPE_SVC_CHANNEL_FUTURE \
  (ring_svc_channel_future_get_type ())
#define RING_SVC_CHANNEL_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RING_TYPE_SVC_CHANNEL_FUTURE, RingSvcChannelFuture))
#define RING_IS_SVC_CHANNEL_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RING_TYPE_SVC_CHANNEL_FUTURE))
#define RING_SVC_CHANNEL_FUTURE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RING_TYPE_SVC_CHANNEL_FUTURE, RingSvcChannelFutureClass))



typedef struct _RingSvcChannelInterfaceMergeableConference RingSvcChannelInterfaceMergeableConference;

typedef struct _RingSvcChannelInterfaceMergeableConferenceClass RingSvcChannelInterfaceMergeableConferenceClass;

GType ring_svc_channel_interface_mergeable_conference_get_type (void);
#define RING_TYPE_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE \
  (ring_svc_channel_interface_mergeable_conference_get_type ())
#define RING_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RING_TYPE_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE, RingSvcChannelInterfaceMergeableConference))
#define RING_IS_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RING_TYPE_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE))
#define RING_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RING_TYPE_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE, RingSvcChannelInterfaceMergeableConferenceClass))


typedef void (*ring_svc_channel_interface_mergeable_conference_merge_impl) (RingSvcChannelInterfaceMergeableConference *self,
    const gchar *in_Channel,
    DBusGMethodInvocation *context);
void ring_svc_channel_interface_mergeable_conference_implement_merge (RingSvcChannelInterfaceMergeableConferenceClass *klass, ring_svc_channel_interface_mergeable_conference_merge_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void ring_svc_channel_interface_mergeable_conference_return_from_merge (DBusGMethodInvocation *context);
static inline void
ring_svc_channel_interface_mergeable_conference_return_from_merge (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


typedef struct _RingSvcChannelInterfaceSplittable RingSvcChannelInterfaceSplittable;

typedef struct _RingSvcChannelInterfaceSplittableClass RingSvcChannelInterfaceSplittableClass;

GType ring_svc_channel_interface_splittable_get_type (void);
#define RING_TYPE_SVC_CHANNEL_INTERFACE_SPLITTABLE \
  (ring_svc_channel_interface_splittable_get_type ())
#define RING_SVC_CHANNEL_INTERFACE_SPLITTABLE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RING_TYPE_SVC_CHANNEL_INTERFACE_SPLITTABLE, RingSvcChannelInterfaceSplittable))
#define RING_IS_SVC_CHANNEL_INTERFACE_SPLITTABLE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RING_TYPE_SVC_CHANNEL_INTERFACE_SPLITTABLE))
#define RING_SVC_CHANNEL_INTERFACE_SPLITTABLE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RING_TYPE_SVC_CHANNEL_INTERFACE_SPLITTABLE, RingSvcChannelInterfaceSplittableClass))


typedef void (*ring_svc_channel_interface_splittable_split_impl) (RingSvcChannelInterfaceSplittable *self,
    DBusGMethodInvocation *context);
void ring_svc_channel_interface_splittable_implement_split (RingSvcChannelInterfaceSplittableClass *klass, ring_svc_channel_interface_splittable_split_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void ring_svc_channel_interface_splittable_return_from_split (DBusGMethodInvocation *context);
static inline void
ring_svc_channel_interface_splittable_return_from_split (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}



G_END_DECLS
